searchData={"items":[{"type":"module","title":"Dicom.BinaryFormat","doc":"DICOM binary format serialization/deserialization as defined in\n[PS 3.5](https://dicom.nema.org/medical/dicom/current/output/chtml/part05/PS3.5.html).","ref":"Dicom.BinaryFormat.html"},{"type":"function","title":"Dicom.BinaryFormat.from_binary/2","doc":"","ref":"Dicom.BinaryFormat.html#from_binary/2"},{"type":"function","title":"Dicom.BinaryFormat.from_binary_until/3","doc":"","ref":"Dicom.BinaryFormat.html#from_binary_until/3"},{"type":"function","title":"Dicom.BinaryFormat.from_file/1","doc":"","ref":"Dicom.BinaryFormat.html#from_file/1"},{"type":"function","title":"Dicom.BinaryFormat.from_file!/1","doc":"","ref":"Dicom.BinaryFormat.html#from_file!/1"},{"type":"function","title":"Dicom.BinaryFormat.read_next_data_element/2","doc":"Read the next data element from a binary.\n\nThis function fails if the binary does not contain at least\none complete data element. Any additional data following the\ndata element is returned as the second element in the returned\ntuple.","ref":"Dicom.BinaryFormat.html#read_next_data_element/2"},{"type":"type","title":"Dicom.BinaryFormat.serialization_options/0","doc":"Options for the de(serialization) of DICOM binaries.\n\nBoth little and big endian byte ordering is supported by\nsetting `endianness` to `:little` or `:big` respectively.\nBig endian encoding is discouraged for new files.\n\nSetting `explicit` to `true` serializes the data elements\nwith their value representations (VRs) included. If it\nis set to `false`, implicit VR encoding is used. Readers\nof implicit VR data sets must have access to a tag dictionary\ndefining the VRs for all contained data elements.","ref":"Dicom.BinaryFormat.html#t:serialization_options/0"},{"type":"function","title":"Dicom.BinaryFormat.serialize/2","doc":"","ref":"Dicom.BinaryFormat.html#serialize/2"},{"type":"function","title":"Dicom.BinaryFormat.serialize_command_data_set/1","doc":"Serialize a DIMSE command data set.\n\nCommand data sets are always encoded with little endian, implicit VR\ntransfer syntax. In addition, the byte length of the command data set\nis prefixed as first element.","ref":"Dicom.BinaryFormat.html#serialize_command_data_set/1"},{"type":"function","title":"Dicom.BinaryFormat.serialize_data_element/2","doc":"Serialize a data element according to the given `serialization_options`.","ref":"Dicom.BinaryFormat.html#serialize_data_element/2"},{"type":"function","title":"Dicom.BinaryFormat.to_file_data/2","doc":"Serializes `data_set` into a full binary string following [DICOM part 10](https://dicom.nema.org/medical/dicom/current/output/html/part10.html#chapter_7).","ref":"Dicom.BinaryFormat.html#to_file_data/2"},{"type":"module","title":"Dicom.DataElement","doc":"A [DICOM data element](https://dicom.nema.org/dicom/2013/output/chtml/part05/chapter_7.html) is one value \nor a list of values with a defined data type and uniquely\nidentified by a tag within a `Dicom.DataSet`.","ref":"Dicom.DataElement.html"},{"type":"function","title":"Dicom.DataElement.binary?/1","doc":"","ref":"Dicom.DataElement.html#binary?/1"},{"type":"function","title":"Dicom.DataElement.from/2","doc":"","ref":"Dicom.DataElement.html#from/2"},{"type":"function","title":"Dicom.DataElement.from/4","doc":"","ref":"Dicom.DataElement.html#from/4"},{"type":"function","title":"Dicom.DataElement.new/3","doc":"","ref":"Dicom.DataElement.html#new/3"},{"type":"function","title":"Dicom.DataElement.sequence?/1","doc":"","ref":"Dicom.DataElement.html#sequence?/1"},{"type":"type","title":"Dicom.DataElement.t/0","doc":"","ref":"Dicom.DataElement.html#t:t/0"},{"type":"function","title":"Dicom.DataElement.tag/1","doc":"","ref":"Dicom.DataElement.html#tag/1"},{"type":"function","title":"Dicom.DataElement.tag/2","doc":"","ref":"Dicom.DataElement.html#tag/2"},{"type":"function","title":"Dicom.DataElement.value/2","doc":"","ref":"Dicom.DataElement.html#value/2"},{"type":"module","title":"Dicom.DataSet","doc":"A [DICOM data set](https://dicom.nema.org/dicom/2013/output/chtml/part05/chapter_7.html) is a collection of `Dicom.DataElement`s uniquely identified by their numeric tags.","ref":"Dicom.DataSet.html"},{"type":"function","title":"Dicom.DataSet.empty/0","doc":"Create an empty data set.","ref":"Dicom.DataSet.html#empty/0"},{"type":"function","title":"Examples - Dicom.DataSet.empty/0","doc":"iex> DataSet.empty()","ref":"Dicom.DataSet.html#empty/0-examples"},{"type":"function","title":"Dicom.DataSet.fetch/2","doc":"Fetches the `Dicom.DataElement` identified by `key` from the `ds`.\n\nIf `ds` contains the element, it is returned in the shape of `{:ok, element}`. If not,\nthe atom `:error` is returned instead.","ref":"Dicom.DataSet.html#fetch/2"},{"type":"function","title":"Examples - Dicom.DataSet.fetch/2","doc":"iex> ds = DataSet.from_keyword_list(PatientID: \"JDOE123\")\n    iex> {:ok, _element} = DataSet.fetch(ds, :PatientID)\n    iex> {:ok, _element} = DataSet.fetch(ds, {0x0010, 0x0020})\n    iex> {:ok, _element} = DataSet.fetch(ds, 0x00100020)\n    iex> :error = DataSet.fetch(ds, :StudyID)","ref":"Dicom.DataSet.html#fetch/2-examples"},{"type":"function","title":"Dicom.DataSet.fetch!/2","doc":"Fetches the `Dicom.DataElement` for `key` from `ds`, erroring out if it does not exist.\n\nIf `ds` contains `key`, the `Dicom.DataElement` is returned. If not,\na `KeyError` exception is raised.","ref":"Dicom.DataSet.html#fetch!/2"},{"type":"function","title":"Examples - Dicom.DataSet.fetch!/2","doc":"iex> ds = DataSet.from_keyword_list(PatientID: \"JDOE123\")\n    iex> _element = DataSet.fetch!(ds, :PatientID)","ref":"Dicom.DataSet.html#fetch!/2-examples"},{"type":"function","title":"Dicom.DataSet.file_meta/1","doc":"Access `file_meta` of a data set.\n\nReturns an empty data set if no `file_meta` exists.","ref":"Dicom.DataSet.html#file_meta/1"},{"type":"function","title":"Dicom.DataSet.from_elements/1","doc":"Create a data set from a enumerable of `Dicom.DataElement`s.","ref":"Dicom.DataSet.html#from_elements/1"},{"type":"function","title":"Examples - Dicom.DataSet.from_elements/1","doc":"iex> (for i <- 1..3, do: Dicom.DataElement.from(0x0021, i, :US, i))\n    ...> |> Dicom.DataSet.from_elements()","ref":"Dicom.DataSet.html#from_elements/1-examples"},{"type":"function","title":"Dicom.DataSet.from_keyword_list/1","doc":"Create a data set from a keyword-value mapping.\n\nAll keywords must be contained in the data dictionary.","ref":"Dicom.DataSet.html#from_keyword_list/1"},{"type":"function","title":"Examples - Dicom.DataSet.from_keyword_list/1","doc":"iex> Dicom.DataSet.from_keyword_list(PatientID: \"JDOE123\", PatientName: \"Doe^John\")","ref":"Dicom.DataSet.html#from_keyword_list/1-examples"},{"type":"function","title":"Dicom.DataSet.has_key?/2","doc":"Checks if `data_set` contains an element `key`.","ref":"Dicom.DataSet.html#has_key?/2"},{"type":"function","title":"Examples - Dicom.DataSet.has_key?/2","doc":"iex> ds = DataSet.from_keyword_list(StudyID: \"1.2.3\")\n    iex> DataSet.has_key?(ds, :StudyID)\n    true\n    iex> DataSet.has_key?(ds, :PatientID)\n    false","ref":"Dicom.DataSet.html#has_key?/2-examples"},{"type":"type","title":"Dicom.DataSet.key_type/0","doc":"Index value to access an element inside a data set.\n\nIt can be either:\n\n1. an atom representing a known element keyword from the data dictionary,\n2. a 32-bit integer representing the tag or\n3. a tuple of 2 16-bit integers representing group and element of the tag respectively.","ref":"Dicom.DataSet.html#t:key_type/0"},{"type":"function","title":"Dicom.DataSet.put/4","doc":"Updates element identified by `key` in `data_set`.\n\nThe element identified by `key` is updated to `value_representation`\nand `values`. If `key` already exists, it is overridden.\n\nReturns the updated data set.","ref":"Dicom.DataSet.html#put/4"},{"type":"function","title":"Examples - Dicom.DataSet.put/4","doc":"iex> ds = DataSet.empty()\n    ...>      |> DataSet.put(:SOPInstanceUID, :UI, [\"1.2.3\"])\n    iex> DataSet.value_for!(ds, :SOPInstanceUID)\n    \"1.2.3\"","ref":"Dicom.DataSet.html#put/4-examples"},{"type":"function","title":"Dicom.DataSet.put_default/4","doc":"Set a default value for `key` in `data_set` if there is no existing value.","ref":"Dicom.DataSet.html#put_default/4"},{"type":"function","title":"Examples - Dicom.DataSet.put_default/4","doc":"iex> ds = DataSet.from_keyword_list(StudyID: \"1.2.3\")\n    iex> ds = ds\n    ...>      |> DataSet.put_default(:PatientID, :SH, [\"PAT123\"])\n    ...>      |> DataSet.put_default(:StudyID, :SH, [\"already_set\"])\n    iex> DataSet.value_for!(ds, :PatientID)\n    \"PAT123\"\n    iex> DataSet.value_for!(ds, :StudyID)\n    \"1.2.3\"","ref":"Dicom.DataSet.html#put_default/4-examples"},{"type":"type","title":"Dicom.DataSet.t/0","doc":"","ref":"Dicom.DataSet.html#t:t/0"},{"type":"function","title":"Dicom.DataSet.value_for!/3","doc":"Fetches the value of the data element identified by `key`.\n\nThis is a shortcut to directly access a specific value. If the\ndata element has a value multiplicity > 1, a specific index can\nbe accessed with the `index` parameter.","ref":"Dicom.DataSet.html#value_for!/3"},{"type":"function","title":"Examples - Dicom.DataSet.value_for!/3","doc":"iex> ds = DataSet.from_keyword_list(OtherPatientNames: [\"Max\", \"Tom\"])\n    iex> DataSet.value_for!(ds, :OtherPatientNames, 1)\n    \"Tom\"","ref":"Dicom.DataSet.html#value_for!/3-examples"},{"type":"function","title":"Dicom.DataSet.with_file_meta_from_keywords/2","doc":"Add `file_meta` to dataset by the `meta_attributes` keyword list.","ref":"Dicom.DataSet.html#with_file_meta_from_keywords/2"},{"type":"function","title":"Examples - Dicom.DataSet.with_file_meta_from_keywords/2","doc":"iex> ds = DataSet.from_keyword_list(SOPInstanceUID: \"1.2.3\")\n    ...>      |> DataSet.with_file_meta_from_keywords(TransferSyntaxUID: \"1.2.840.10008.1.2.1\")\n    iex> ds\n    ...> |> DataSet.file_meta()\n    ...> |> DataSet.value_for!(:TransferSyntaxUID)\n    \"1.2.840.10008.1.2.1\"","ref":"Dicom.DataSet.html#with_file_meta_from_keywords/2-examples"},{"type":"function","title":"Dicom.DataSet.with_transfer_syntax/2","doc":"Add transfer syntax by `transfer_syntax_name` to `file_meta` of `data_set`.","ref":"Dicom.DataSet.html#with_transfer_syntax/2"},{"type":"function","title":"Examples - Dicom.DataSet.with_transfer_syntax/2","doc":"iex> ds = DataSet.empty()\n    ...>      |> DataSet.with_transfer_syntax(:explicit_vr_little_endian)\n    iex> ds\n    ...> |> DataSet.file_meta()\n    ...> |> DataSet.value_for!(:TransferSyntaxUID)\n    \"1.2.840.10008.1.2.1\"","ref":"Dicom.DataSet.html#with_transfer_syntax/2-examples"},{"type":"module","title":"Dicom.TagDict","doc":"","ref":"Dicom.TagDict.html"},{"type":"function","title":"Dicom.TagDict.get_by_tag_parts/3","doc":"","ref":"Dicom.TagDict.html#get_by_tag_parts/3"},{"type":"function","title":"Dicom.TagDict.get_tag_parts_by_keyword/1","doc":"","ref":"Dicom.TagDict.html#get_tag_parts_by_keyword/1"},{"type":"module","title":"Dicom.TagDict.Dict","doc":"","ref":"Dicom.TagDict.Dict.html"},{"type":"function","title":"Dicom.TagDict.Dict.by_tag/0","doc":"","ref":"Dicom.TagDict.Dict.html#by_tag/0"},{"type":"module","title":"Dicom.UidRegistry","doc":"","ref":"Dicom.UidRegistry.html"},{"type":"function","title":"Dicom.UidRegistry.get_default_transfer_syntax/0","doc":"","ref":"Dicom.UidRegistry.html#get_default_transfer_syntax/0"},{"type":"function","title":"Dicom.UidRegistry.get_transfer_syntax/1","doc":"","ref":"Dicom.UidRegistry.html#get_transfer_syntax/1"},{"type":"function","title":"Dicom.UidRegistry.get_transfer_syntax_uid_by_name!/1","doc":"","ref":"Dicom.UidRegistry.html#get_transfer_syntax_uid_by_name!/1"},{"type":"module","title":"DicomNet.Association","doc":"Defines a DICOM association.\n\nA DICOM association represents an established network connection\nbetween two application entities (AEs). The association is the result\nof successfully negotiating user identities, what data will be\nexchanged and how it will be encoded.\n\nSee also:\n  * https://dicom.nema.org/dicom/2013/output/chtml/part07/sect_D.3.html","ref":"DicomNet.Association.html"},{"type":"function","title":"DicomNet.Association.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"DicomNet.Association.html#child_spec/1"},{"type":"function","title":"DicomNet.Association.start/1","doc":"","ref":"DicomNet.Association.html#start/1"},{"type":"module","title":"DicomNet.Endpoint","doc":"Defines a DICOM network endpoint.\n\nThe endpoint is the boundary where all DICOM upper layer network connection\nenter the system. For every connection, a `DicomNet.Association` is instantiated.\nIf the assocation is established successfully, received DICOM operations\nare forwarded to registered listeners as messages.\n\nSee also:\n  * https://dicom.nema.org/dicom/2013/output/chtml/part08/chapter_9.htm","ref":"DicomNet.Endpoint.html"},{"type":"function","title":"DicomNet.Endpoint.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"DicomNet.Endpoint.html#child_spec/1"},{"type":"function","title":"DicomNet.Endpoint.start_link/1","doc":"","ref":"DicomNet.Endpoint.html#start_link/1"},{"type":"module","title":"DicomNet.Pdu","doc":"This module implements the DICOM upper layer network protocol according to\n[PS 3.8](https://dicom.nema.org/dicom/2013/output/chtml/part08/PS3.8.html).","ref":"DicomNet.Pdu.html"},{"type":"function","title":"DicomNet.Pdu.from_data/1","doc":"","ref":"DicomNet.Pdu.html#from_data/1"},{"type":"function","title":"DicomNet.Pdu.new_associate_accept_response_pdu/1","doc":"","ref":"DicomNet.Pdu.html#new_associate_accept_response_pdu/1"},{"type":"function","title":"DicomNet.Pdu.new_association_reject_response_pdu/2","doc":"","ref":"DicomNet.Pdu.html#new_association_reject_response_pdu/2"},{"type":"function","title":"DicomNet.Pdu.new_association_release_response_pdu/0","doc":"","ref":"DicomNet.Pdu.html#new_association_release_response_pdu/0"},{"type":"function","title":"DicomNet.Pdu.new_data_pdu/3","doc":"","ref":"DicomNet.Pdu.html#new_data_pdu/3"},{"type":"function","title":"DicomNet.Pdu.parse/1","doc":"","ref":"DicomNet.Pdu.html#parse/1"},{"type":"function","title":"DicomNet.Pdu.serialize/1","doc":"","ref":"DicomNet.Pdu.html#serialize/1"},{"type":"task","title":"mix dicom.dump","doc":"Read and pretty print DICOM file.","ref":"Mix.Tasks.Dicom.Dump.html"},{"type":"function","title":"Mix.Tasks.Dicom.Dump.run/1","doc":"","ref":"Mix.Tasks.Dicom.Dump.html#run/1"},{"type":"task","title":"mix dicom.scp","doc":"Run a standalone C-STORE SCP service class provider (SCP).\n\nThe task takes following arguments:\n\n* `--port  `: Port to listen on for incoming DICOM connections\n* `--print`: If set, received data sets are printed to standard out.\n* `--save  `: If set, received data sets are saved under base path.","ref":"Mix.Tasks.Dicom.Scp.html"},{"type":"task","title":"Examples - mix dicom.scp","doc":"mix dicom.scp --port 4242 --print --save ./scp_incoming","ref":"Mix.Tasks.Dicom.Scp.html#module-examples"},{"type":"function","title":"Mix.Tasks.Dicom.Scp.run/1","doc":"","ref":"Mix.Tasks.Dicom.Scp.html#run/1"},{"type":"task","title":"mix dicom.tagdict.create","doc":"Downloads and parses the tag dictionaries and generates a Elixir module.","ref":"Mix.Tasks.Dicom.Tagdict.Create.html"},{"type":"function","title":"Mix.Tasks.Dicom.Tagdict.Create.run/1","doc":"","ref":"Mix.Tasks.Dicom.Tagdict.Create.html#run/1"},{"type":"extras","title":"Dicom.ex","doc":"# Dicom.ex\n\nDicom.ex is a Elixir library implementing the [DICOM](https://www.dicomstandard.org/)\nstandard for data storage and network transfers.\n\n**Attention:** This project is a personal project to\nlearn Elixir and DICOM internals. It should not be used\nin production and absolutely not in clinical contexts.","ref":"readme.html"},{"type":"extras","title":"Features - Dicom.ex","doc":"* General methods to work with DICOM data sets and elements\n* Read/write \"part 10\" DICOM files ([DICOM Part 3.10](https://dicom.nema.org/medical/dicom/current/output/chtml/part10/chapter_7.html))\n* Supports VRs and tag dictionary as of DICOM version 2024d\n* Handle C-ECHO, C-FIND and C-STORE network requests ([DICOM Part 3.7](https://dicom.nema.org/medical/dicom/current/output/chtml/part07/PS3.7.html))","ref":"readme.html#features"},{"type":"extras","title":"Tools and Examples - Dicom.ex","doc":"","ref":"readme.html#tools-and-examples"},{"type":"extras","title":"Loading and Displaying DICOM Files - Dicom.ex","doc":"The mix task [dicom.dump](lib/mix/tasks/dicom.dump.ex) contains a minimal example of how to load and display DICOM files.\n\nUsage:\n\n    mix dicom.dump path/to/file.dcm","ref":"readme.html#loading-and-displaying-dicom-files"},{"type":"extras","title":"Receiving DICOM Network Transfers - Dicom.ex","doc":"The mix task [dicom.scp](lib/mix/tasks/dicom.scp.ex) runs a minimal storage service provider (SCP) capable\nof printing and saving received data sets.\n\nUsage:\n\n    mix dicom.scp --port 8104 --print --save ./scp_incoming","ref":"readme.html#receiving-dicom-network-transfers"},{"type":"extras","title":"Examples - Dicom.ex","doc":"","ref":"readme.html#examples"},{"type":"extras","title":"DICOM parsing and writing - Dicom.ex","doc":"The following examples shows how to parse and access/write data from/to dicom files.","ref":"readme.html#dicom-parsing-and-writing"},{"type":"extras","title":"Create and access DICOM data set - Dicom.ex","doc":"```elixir\nds =\n  Dicom.DataSet.from_keyword_list(\n    SOPInstanceUID: \"1.2.3\",\n    PatientID: \"ABC123\",\n    ImageType: [\"Test1\", \"Test2\", \"Test3\"]\n  )\n\nassert Dicom.DataSet.value_for!(ds, :PatientID) == \"ABC123\"\nassert Dicom.DataSet.value_for!(ds, :ImageType, 2) == \"Test3\"\n```","ref":"readme.html#create-and-access-dicom-data-set"},{"type":"extras","title":"Read/Write DICOM Data Set From/To File - Dicom.ex","doc":"```elixir\nserialized =\n  Dicom.BinaryFormat.from_file!(\"demo.dcm\")\n  |> Dicom.DataSet.put(:PatientID, :SH, [\"ANON123\"])\n  |> Dicom.DataSet.put(:PatientName, :PN, [\"Doe^John\"])\n  |> Dicom.BinaryFormat.to_file_data()\nFile.write!(\"anonymized.dcm\", serialized)\n```","ref":"readme.html#read-write-dicom-data-set-from-to-file"},{"type":"extras","title":"DICOM DIMSE Handlers - Dicom.ex","doc":"The following examples show how to create DICOM DIMSE services.","ref":"readme.html#dicom-dimse-handlers"},{"type":"extras","title":"Association Validation - Dicom.ex","doc":"This example allows incoming requests pointing to `TEST` AETitle, all other AETitles are rejected.  \n\nTo test an _accepting association_ you could run echoscu (from [dcmtk](https://dicom.offis.de/dcmtk.php.en)) this way:  \n\n```\nechoscu -d -aec TEST 127.0.0.1 4242\n```\n\nTo test an _rejecting association_:  \n\n```\nechoscu -d -aec OTHERAET 127.0.0.1 4242\n```\n\n```elixir\ndefmodule AssociationExample do\n  use Application\n\n  def start(_type, _args) do\n    {:ok, endpoint_pid} = GenServer.start_link(\n      DicomNet.Endpoint, \n      port: 4242,\n      event_handlers: [\n        association_validator: &association_handler/1,\n      ]\n    )\n\n    loop()\n    {:ok, endpoint_pid}\n  end\n\n  # Whithout this the server won't keep running\n  defp loop() do\n    loop()\n  end\n\n  defp association_handler(association_data) do\n    case association_data.called_ae_title do\n      \"TEST\" ->\n        :accept\n      _ ->\n        {:reject, :dicom_ul_service_user, :called_ae_title_not_recognized}\n    end\n  end\nend\n```","ref":"readme.html#association-validation"},{"type":"extras","title":"C-FIND SCP - Dicom.ex","doc":"Adding up to the association validation example, we'll add a `cfind` handler:  \n\n```elixir\ndefmodule CFindSCP do\n  use Application\n\n  def start(_type, _args) do\n    {:ok, endpoint_pid} = GenServer.start_link(\n      DicomNet.Endpoint, \n      port: 4242,\n      event_handlers: [\n        cfind: &get_responses/1,\n        association_validator: &association_handler/1,\n      ]\n    )\n\n    loop()\n    {:ok, endpoint_pid}\n  end\n\n  # Whithout this the server won't keep running\n  defp loop() do\n    loop()\n  end\n\n  defp association_handler(association_data) do\n    case association_data.called_ae_title do\n      \"TEST\" ->\n        :accept\n      _ ->\n        {:reject, :dicom_ul_service_user, :called_ae_title_not_recognized}\n    end\n  end\n\n  defp get_responses(dataset) do\n    # Rename tags with atoms\n    fields = Enum.map(dataset, fn {k, v} ->\n          group = v.group_number\n          element = v.element_number\n          values = v.values\n          case {group, element} do\n              {0x0008, 0x0050} -> {:AccessionNumber, values}\n              {0x0010, 0x0010} -> {:PatientName, values}\n              {0x0010, 0x0020} -> {:PatientID, values}\n            _ -> {:Ignore, nil}\n          end\n        end\n    ) \n\n    # sample study list\n    studies = [\n      [\"PatientName\": \"Carmack^John\", PatientID: \"1\", AccessionNumber: \"A001\"],\n      [\"PatientName\": \"Kernighan^Brian\", PatientID: \"2\", AccessionNumber: \"A002\"],\n      [\"PatientName\": \"Torvalds^Linus\", PatientID: \"3\", AccessionNumber: \"A003\"],\n      [\"PatientName\": \"Van Rossum^Guido\", PatientID: \"4\", AccessionNumber: \"A004\"],\n      [\"PatientName\": \"Valim^José\", PatientID: \"5\", AccessionNumber: \"A005\"]\n    ]\n\n    # Return the list excluding those fields not present in fields list.\n    Stream.map(studies, fn study ->\n      Keyword.take(study, Keyword.keys(fields)) \n      |>Dicom.DataSet.from_keyword_list()\n    end) \n  end\n\nend\n```","ref":"readme.html#c-find-scp"},{"type":"extras","title":"C-STORE SCP - Dicom.ex","doc":"This last example includes all the handlers available at this moment, `association_validator`, `cfind` and `cstore`.  \n\n```elixir\ndefmodule SCP do\n  use Application\n\n  def start(_type, _args) do\n    {:ok, endpoint_pid} = GenServer.start_link(\n      DicomNet.Endpoint, \n      port: 4242,\n      event_handlers: [\n        cfind: &get_responses/1,\n        cstore: &store_image/1,\n        association_validator: &association_handler/1,\n      ]\n    )\n\n    loop()\n    {:ok, endpoint_pid}\n  end\n\n  # Whithout this the server won't keep running\n  defp loop() do\n    loop()\n  end\n\n  defp association_handler(association_data) do\n    case association_data.called_ae_title do\n      \"TEST\" ->\n        :accept\n      _ ->\n        {:reject, :dicom_ul_service_user, :called_ae_title_not_recognized}\n    end\n  end\n\n  defp get_responses(dataset) do\n    # Rename tags with atoms\n    fields = Enum.map(dataset, fn {k, v} ->\n          group = v.group_number\n          element = v.element_number\n          values = v.values\n          case {group, element} do\n              {0x0008, 0x0050} -> {:AccessionNumber, values}\n              {0x0010, 0x0010} -> {:PatientName, values}\n              {0x0010, 0x0020} -> {:PatientID, values}\n            _ -> {:Ignore, nil}\n          end\n        end\n    ) \n\n    # sample study list\n    studies = [\n      [\"PatientName\": \"Carmack^John\", PatientID: \"1\", AccessionNumber: \"A001\"],\n      [\"PatientName\": \"Kernighan^Brian\", PatientID: \"2\", AccessionNumber: \"A002\"],\n      [\"PatientName\": \"Torvalds^Linus\", PatientID: \"3\", AccessionNumber: \"A003\"],\n      [\"PatientName\": \"Van Rossum^Guido\", PatientID: \"4\", AccessionNumber: \"A004\"],\n      [\"PatientName\": \"Valim^José\", PatientID: \"5\", AccessionNumber: \"A005\"]\n    ]\n\n    # Return the list excluding those fields not present in fields list.\n    Stream.map(studies, fn study ->\n      Keyword.take(study, Keyword.keys(fields)) \n      |>Dicom.DataSet.from_keyword_list()\n    end) \n  end\n\n  defp store_image(data) do\n    # just print the incoming dataset\n    IO.inspect(data, label: \"C-STORE\")\n  end\n\nend\n```","ref":"readme.html#c-store-scp"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}